﻿/***
	credits
		October/November 2009 - http://www.musicofelectricity.net
		Music of Electricity Flash Toy by samuel.freeman - http://sdfphd.net
		Commissioned by the Hudderfield Contemporary Music Festival - http://www.hcmf.co.uk
		In collaboration with Duncan Chapman - http://www.duncanchapman.org/ 
		AS3 code help -	http://www.FlashEssential.com
***/

// vars from tutorial patch still in use (some do have name chaged)
var xml:XML;
var mp3list:XMLList;
var getMusic:URLRequest;
var soundChannel:SoundChannel;

// sdf vars...
// **** general globally used/reused values ****
var i:int,j:int, eX:int, eY:int, nX:int, nY:int, tX:int, tY:int; 

const sqrSize:int = 20;

var index:int = -1; // ++ happens before var is used in call back loop

var numMp3s:int;
var mp3Array:Array;
var spriteArray:Array;

var erList:Array = new Array(); //error list for failed mp3 load indexs
var erListCount:int = 0;

var clrTrans:ColorTransform = new ColorTransform();

var grid:Array = new Array(20);
	for (i=0; i<20; i++) {
		grid[i]=new Array(20);
		for (j=0; j<20; j++) {
			grid[i][j] = int(-1); //grid[x][y] holds index of sprite sitting there OR -1 if no one at location
		}
	}




// **** random value functions ****

function randomiseClr(colourName:String):void{
	var ranVal = randomValue();
	if (colourName == "red" || colourName == "yellow" || colourName == "magenta") clrTrans.redOffset = ranVal;
	else	clrTrans.redOffset = 0;
	if (colourName == "green" || colourName == "yellow" || colourName == "aqua") clrTrans.greenOffset = ranVal;
	else	clrTrans.greenOffset = 0;
	if (colourName == "blue" || colourName == "magenta" || colourName == "aqua") clrTrans.blueOffset = ranVal;
	else	clrTrans.blueOffset = 0;
} // end of function randomiseClr(colourName:String):void

function randomValue():int{ return (Math.random()*127)+127; } // random using upper half of range for colours

function randomCoord():int{ return Math.min(380,Math.round(Math.random()*19)*20); } //coord snaps to grid!

function randomIndex():int{	
	var r:int;
	var ok:Boolean = false;
	while(!ok){
		r = Math.min(numMp3s-1,Math.round(Math.random()*numMp3s));
		ok = true;
		for (i=0; i<erList.length; i++) if (r==erList[i]) ok = false;
	}//end while
	return r;
} // end of function randomIndex():int

/*-------------------Load in Our XML ------------------------*/
var loader:URLLoader = new URLLoader(); //create a new URLLoader Object 
loader.addEventListener(Event.COMPLETE, whenLoaded); //add an event listener to that object 
loader.load(new URLRequest("mp3list.xml")); //Requests our xml file that contains our song data

function whenLoaded(e:Event):void // called after .xml file is loaded at start up
{
	clrTrans.redMultiplier = 0;
	clrTrans.greenMultiplier = 0; 
	clrTrans.blueMultiplier = 0; 
	
	xml = new XML(e.target.data);  	//copy data from loaded file to var 
	mp3list = xml.mp3; 				//get list data into var
	
	numMp3s = mp3list.length()		
	mp3Array = new Array(numMp3s);
	spriteArray = new Array(numMp3s);
	
	makeA(e); // pass on the Event to the looping function
}//end function whenLoaded(e:Event):void

function makeA(e:Event):void{ // this function loops via call back
	index++;
	if (index < numMp3s){ 
		//trace("new sound obj");
		mp3Array[index] = new Sound();
			getMusic = new URLRequest(mp3list[index].url);
			mp3Array[index].load(getMusic);
			mp3Array[index].addEventListener(IOErrorEvent.IO_ERROR, onSoundIOError, false, 0, true);//catch error
			mp3Array[index].addEventListener(Event.COMPLETE, makeB);	// call makeB when mp3 has loaded 
	}//end if (index < numMp3s)
}//end function makeA(e:Event):void

function onSoundIOError (e:IOErrorEvent)
{
	//trace("An Error Occured and it looked like this.", e.text);
	//trace("index "+index);
	erList[erListCount] = index; //add current index to error list
	erListCount++;
	makeA(e); // call back without doing makeB
}//end function onSoundIOError (e:IOErrorEvent)

function makeB(e:Event):void{
	//trace("new sprite");
	spriteArray[index] = new Sprite();
		randomiseClr(mp3list[index].colour); // randomise the brightness of the colour named for this mp3
			spriteArray[index].graphics.beginFill(clrTrans.color);
			spriteArray[index].graphics.drawRect(0,0,sqrSize,sqrSize);
			spriteArray[index].graphics.endFill();
		j = 0;
		while(j!=-1){// randomly choose new cells, til you find one that's free
			nX = randomCoord();
			nY = randomCoord();
				tX = nX/sqrSize;	//convert stage x,y to grid cell x,y
				tY = nY/sqrSize;
					j = grid[tX][tY];
		}// end while looking for a free cell
		spriteArray[index].x = nX;
		spriteArray[index].y = nY;
		grid[tX][tY] = [index];
		spriteArray[index].addEventListener(MouseEvent.MOUSE_OVER, mo);
		spriteArray[index].addEventListener(MouseEvent.MOUSE_DOWN, md);
		spriteArray[index].addEventListener(MouseEvent.MOUSE_UP, mu);
		spriteArray[index].buttonMode = true;
		spriteArray[index].useHandCursor = true;
		addChild(spriteArray[index]);
	makeA(e); // call back to first part of make loop
}//end function makeB(e:Event):void

/******** event handlers ********/
function mu(evt:MouseEvent):void { //mu = mouse up
	//trace("this shouldn't happen");
	evt.target.x = randomCoord();
	evt.target.y = randomCoord();
	//not checking for a free cell to jump to bcus this sprite is already off-grid
}
function md(evt:MouseEvent):void { //md = mouse down
			soundChannel = mp3Array[randomIndex()].play(); // play an mp3 at random
			mo(evt); // pass on event to mouse over function
}
function mo(evt:MouseEvent):void { //mo = mouse over
	eX = evt.stageX/sqrSize;	//convert mouse x,y to grid cell x,y
	eY = evt.stageY/sqrSize;
	i = grid[eX][eY]; // get index at this grid loacation
	if (i != -1){	// if this grid cell has a sprite index in it...
		j = 0;
		while(j!=-1){// randomly choose new cells, til you find one that's free
			nX = randomCoord();
			nY = randomCoord();
			tX = nX/sqrSize;	//convert stage x,y to grid cell x,y
			tY = nY/sqrSize;
			j = grid[tX][tY];
		}// end while looking for a free cell
		grid[tX][tY] = [i]; // put index into new grid cell
		evt.target.x = nX;	// move to new grid cell
		evt.target.y = nY;
		grid[eX][eY] = -1;	// clear old grid cell
		soundChannel = mp3Array[i].play(); // play the mp3!!
	}//end if grid cell has a sprite index in it
}//end function mo(evt:MouseEvent):void